import re
import imLib.Category as Category
import imLib.Request as Request

headingPat = re.compile(r'^(?P<heading_marker>={1,6})[ \t]+(?P<heading>[^\r\n]+?)[ \t]+(?P=heading_marker)[\r]?[\n]?$', re.MULTILINE)

def extract(text):
	return headingPat.findall(text)

def toRelativeLevel(headingList):
	L = []
	lastLevel = 0
	for markup, text in headingList:
		level = len(markup)
		L.append((level - lastLevel, text))
		lastLevel = level
	return L

def formatting(rHeadingList):
	L = ['<dl><dt>Table Of Contents</dt>'] # FIXME
	numOfOpened = 0
	for level, text in rHeadingList:
		if level >= 0: markup = '<dd><dl>'
		else: markup = '</dl></dd>'
		numOfOpened = numOfOpened + level
 		markup = markup * abs(level)
		L.append('%s<dt><a href="#%s">%s</a></dt>' % (markup, text,text))
	L.append('</dl></dd>' * numOfOpened)
	L.append('</dl>')
	return ''.join(L)

def run():
	request = Request.Request()
	category = Category.getCategoryByCategoryPath(request.categoryPath)
	page = category.getPage(request.pageName)
	headingList = toRelativeLevel(extract(page.rawText))
	return formatting(headingList)


